unit EcrPrin;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TEcrDemoDrawEdge = class(TForm)
    rgEdge: TRadioGroup;
    rgInner: TRadioGroup;
    rgOuter: TRadioGroup;
    gbFlags: TGroupBox;
    cbAdjust: TCheckBox;
    cbB: TCheckBox;
    cbL: TCheckBox;
    cbR: TCheckBox;
    cbT: TCheckBox;
    cbDiagonal: TCheckBox;
    GroupBox1: TGroupBox;
    cbBL: TCheckBox;
    cbBR: TCheckBox;
    cbTR: TCheckBox;
    cbTL: TCheckBox;
    cbRect: TCheckBox;
    cbMiddle: TCheckBox;
    cbFlat: TCheckBox;
    cbMono: TCheckBox;
    cbSoft: TCheckBox;
    lbResult: TLabel;
    cbDiagTR: TCheckBox;
    cbDiagTL: TCheckBox;
    cbDiagBL: TCheckBox;
    cbDiagBR: TCheckBox;
    procedure rgEdgeClick(Sender: TObject);
    procedure gbInnerOuterClick(Sender: TObject);
    procedure cbFlagClick(Sender: TObject);
    procedure cbCombinaisonClick(Sender: TObject);
    procedure cbRectClick(Sender: TObject);
    procedure cbDiagClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private { Dclarations prives }
    Procedure MajDessin;
  public  { Dclarations publiques }
  end;

var
  EcrDemoDrawEdge: TEcrDemoDrawEdge;

implementation

{$R *.dfm}

Procedure TEcrDemoDrawEdge.MajDessin;
Var Edge : UInt;
    Flags : UInt;
    R : TRect;
    Res : Integer;
Begin
  Edge := 0;
  Case rgInner.ItemIndex of
    0:{Raised} Edge := BDR_RAISEDINNER;
    1:{Sunken} Edge := BDR_SUNKENINNER;
  End;
  Case rgOuter.ItemIndex of
    0:{Raised} Edge := Edge + BDR_RAISEDOUTER;
    1:{Sunken} Edge := Edge + BDR_SUNKENOUTER;
  End;

  Flags := 0;
  If cbL.Checked   then Flags := Flags + BF_LEFT;      //$0001
  If cbTL.Checked    then Flags := Flags + BF_TOP;       //$0002
  If cbR.Checked  then Flags := Flags + BF_RIGHT;     //$0004
  If cbB.Checked then Flags := Flags + BF_BOTTOM;    //$0008

  If cbDiagonal.Checked then Flags := Flags + BF_DIAGONAL;//$0010
  If cbMiddle.Checked   then Flags := Flags + BF_MIDDLE;  //$0800
  If cbSoft.Checked     then Flags := Flags + BF_SOFT;    //$1000 For softer buttons
  If cbAdjust.Checked   then Flags := Flags + BF_ADJUST;  //$2000 Calculate the space left over
  If cbFlat.Checked     then Flags := Flags + BF_FLAT;    //$4000 For flat rather than 3D borders
  If cbMono.Checked     then Flags := Flags + BF_MONO;    //$8000 For monochrome borders

  R := Rect(8, 180, 8+289, 180+30);
  Canvas.Brush.Color := clWindow; //Efface zone travail
  Canvas.FillRect(R);

  LongBool(Res) := DrawEdge(Canvas.Handle, R, Edge, Flags);
  lbResult.Caption := 'Result = '+IntToStr(Res);
  If Res=0 then
  Begin
    Res := GetLastError;
    lbResult.Caption := lbResult.Caption + ' -> LastError = '+IntToStr(Res);
  End;
End;

procedure TEcrDemoDrawEdge.rgEdgeClick(Sender: TObject);
begin
  Case rgEdge.ItemIndex of
    0: //Bump
    Begin
      rgOuter.ItemIndex := 0; //RaisedOuter
      rgInner.ItemIndex := 1; //SunkenInner
    End;
    1: //Etched
    Begin
      rgOuter.ItemIndex := 1; //SunkenOuter
      rgInner.ItemIndex := 0; //RaisedInner
    End;
    2: //Raised
    Begin
      rgOuter.ItemIndex := 0; //RaisedOuter
      rgInner.ItemIndex := 0; //RaisedInner
    End;
    3: //Sunken
    Begin
      rgOuter.ItemIndex := 1; //SunkenOuter
      rgInner.ItemIndex := 1; //SunkenInner
    End;
  End;
end;

procedure TEcrDemoDrawEdge.FormPaint(Sender: TObject);
begin
  MajDessin;
end;

procedure TEcrDemoDrawEdge.gbInnerOuterClick(Sender: TObject);
begin
  Case rgOuter.ItemIndex of
    0://Raised
      Case rgInner.ItemIndex of
        0:{Raised} rgEdge.ItemIndex := 2;  //Raised
        1:{Sunken} rgEdge.ItemIndex := 0;  //Bump
        2:{none}   rgEdge.ItemIndex := -1; //None
      End;
    1 ://Sunken
      Case rgInner.ItemIndex of
        0:{Raised} rgEdge.ItemIndex := 1;  //Etched
        1:{Sunken} rgEdge.ItemIndex := 3;  //Sunken
        2:{none}   rgEdge.ItemIndex := -1; //None
      End;
    2 ://None
      rgEdge.ItemIndex := -1; //None
  End;
  MajDessin;
end;

Procedure ChangeCB(CB:TCheckBox; Etat:Boolean);
Var OC : TNotifyEvent;
Begin
  OC := CB.OnClick;
  CB.OnClick := Nil;
  CB.Checked := Etat;
  CB.OnClick := OC;
End;

procedure TEcrDemoDrawEdge.cbFlagClick(Sender: TObject);
begin
  ChangeCB(cbTL, cbT.Checked and cbL.Checked);
  ChangeCB(cbTR, cbT.Checked and cbR.Checked);
  ChangeCB(cbBL, cbB.Checked and cbL.Checked);
  ChangeCB(cbBR, cbB.Checked and cbR.Checked);

  ChangeCB(cbRect, cbT.Checked and cbL.Checked and cbB.Checked and cbR.Checked);

  ChangeCB(cbDiagTL, cbDiagonal.Checked and cbTL.Checked);
  ChangeCB(cbDiagTR, cbDiagonal.Checked and cbTR.Checked);
  ChangeCB(cbDiagBL, cbDiagonal.Checked and cbBL.Checked);
  ChangeCB(cbDiagBR, cbDiagonal.Checked and cbBR.Checked);

  MajDessin;
end;

procedure TEcrDemoDrawEdge.cbCombinaisonClick(Sender: TObject);
begin
  ChangeCB(cbL, cbTL.Checked or cbBL.Checked);
  ChangeCB(cbR, cbTR.Checked or cbBR.Checked);
  ChangeCB(cbT, cbTL.Checked or cbTR.Checked);
  ChangeCB(cbB, cbBL.Checked or cbBR.Checked);

  ChangeCB(cbRect, cbT.Checked and cbL.Checked and cbB.Checked and cbR.Checked);

  ChangeCB(cbDiagTL, cbDiagonal.Checked and cbTL.Checked);
  ChangeCB(cbDiagTR, cbDiagonal.Checked and cbTR.Checked);
  ChangeCB(cbDiagBL, cbDiagonal.Checked and cbBL.Checked);
  ChangeCB(cbDiagBR, cbDiagonal.Checked and cbBR.Checked);

  MajDessin;
end;

procedure TEcrDemoDrawEdge.cbRectClick(Sender: TObject);
begin
  ChangeCB(cbL, cbRect.Checked);
  ChangeCB(cbR, cbRect.Checked);
  ChangeCB(cbT, cbRect.Checked);
  ChangeCB(cbB, cbRect.Checked);

  ChangeCB(cbTL, cbT.Checked and cbL.Checked);
  ChangeCB(cbTR, cbT.Checked and cbR.Checked);
  ChangeCB(cbBL, cbB.Checked and cbL.Checked);
  ChangeCB(cbBR, cbB.Checked and cbR.Checked);

  ChangeCB(cbDiagTL, cbDiagonal.Checked and cbTL.Checked);
  ChangeCB(cbDiagTR, cbDiagonal.Checked and cbTR.Checked);
  ChangeCB(cbDiagBL, cbDiagonal.Checked and cbBL.Checked);
  ChangeCB(cbDiagBR, cbDiagonal.Checked and cbBR.Checked);

  MajDessin;
end;

procedure TEcrDemoDrawEdge.cbDiagClick(Sender: TObject);
begin
  ChangeCB(cbDiagonal, cbDiagTL.Checked or cbDiagTR.Checked or cbDiagBL.Checked or cbDiagBR.Checked);

  ChangeCB(cbL, cbDiagTL.Checked or cbDiagBL.Checked);
  ChangeCB(cbR, cbDiagTR.Checked or cbDiagBR.Checked);
  ChangeCB(cbT, cbDiagTL.Checked or cbDiagTR.Checked);
  ChangeCB(cbB, cbDiagBL.Checked or cbDiagBR.Checked);

  ChangeCB(cbRect, cbT.Checked and cbL.Checked and cbB.Checked and cbR.Checked);

  ChangeCB(cbTL, cbDiagTL.Checked);
  ChangeCB(cbTR, cbDiagTR.Checked);
  ChangeCB(cbBL, cbDiagBL.Checked);
  ChangeCB(cbBR, cbDiagBR.Checked);

  MajDessin;
end;

end.
